Index: trunk/kernel/kern/signal.c
===================================================================
--- trunk/kernel/kern/signal.c	(revision 1)
+++ trunk/kernel/kern/signal.c	(revision 1)
@@ -0,0 +1,255 @@
+/*
+ * signal.c - signal-management related operations implementation
+ * 
+ * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *         Mohamed Lamine Karaoui (2015)
+ *         Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <hal_types.h>
+#include <errno.h>
+#include <thread.h>
+#include <process.h>
+#include <core.h>
+#include <signal.h>
+
+SIGNAL_HANDLER(kill_sigaction)
+{
+	struct thread_s *this;
+  
+	this = CURRENT_THREAD;
+	this->state = S_KERNEL;
+
+	printk(INFO, "INFO: Recieved signal %d, pid %d, tid %x, core %d  [ KILLED ]\n",
+	       sig,
+	       this->process->pid,
+	       this,
+	       cpu_get_id());
+
+	sys_thread_exit((void*)EINTR);
+}
+
+//////////////////////////////////////////////////
+void signal_manager_init( process_t * process )
+{
+	memset(&process->sig_mgr, 0, sizeof(process->sig_mgr));
+	process->sig_mgr.sigactions[SIGCHLD] = SIG_IGNORE;
+	process->sig_mgr.sigactions[SIGURG]  = SIG_IGNORE;
+}
+
+////////////////////////////////////////
+error_t signal_init( thread_t * thread )
+{
+	thread->info.sig_state = 0;
+	thread->info.sig_mask  = CURRENT_THREAD->info.sig_mask;
+	return 0;
+}
+
+////////////////////////////////////////////////////
+static error_t signal_rise_all( process_t * process, 
+                                uint32_t    sig )
+{
+	thread_t     * thread;
+	uint32_t       i;
+
+	spinlock_lock( &process->th_lock );
+
+	for( i = 0 ; i < process->th_nr ; i++ )
+	{
+		thread = process->th_tbl[i];
+		hal_atomic_or( &thread->signals , (1 << sig) );
+	}
+
+	spinlock_unlock( &process->th_lock );
+
+	sig_dmsg("\n[INFO] %s : %d threads have been signaled for process %d\n",
+                        __FUNCTION__, process->th_nr , process->pid );
+
+	return 0;
+}
+
+////////////////////////////////////////////////////
+static error_t signal_rise_one( process_t * process,
+                                uint32_t    sig )
+{
+	thread_t * thread;
+
+	spinlock_lock( &process->th_lock );
+
+//mdify to current_thread, not the one pointed by the sig_mgr ?
+	if(process->sig_mgr.handler == NULL)
+		thread = list_first(&process->th_root, struct thread_s, rope);
+	else
+		thread = process->sig_mgr.handler;
+
+	spinlock_lock( &thread->lock );
+	thread->info.sig_state |= (1 << sig);
+	spinlock_unlock( &thread->lock );
+
+	spinlock_unlock( &process->th_lock );
+
+    sig_dmsg("\n[INFO] %s : Thread %u of process %u has received signal %u. sig_state = %x\n",        \
+                        __FUNCTION__, thread_current_cpu(thread)->gid,                          \
+                        process->pid, sig, thread->info.sig_state);
+
+	return 0;
+}
+
+RPC_DECLARE( __signal_rise,                             \
+                RPC_RET( RPC_RET_PTR(error_t, err)),    \
+                RPC_ARG( RPC_ARG_VAL(pid_t,   pid),     \
+                         RPC_ARG_VAL(uint32_t,  sig))     \
+           )
+{
+         process_t   * process;
+        struct hnode_s  *hnode;
+
+        /* Avoid killing process0 and init */
+        /* FIXME: Zero should not be hard-coded but obtains with something like MAIN_KERN */
+        if( ((pid == PID_MIN_GLOBAL) || (pid == PID_MIN_GLOBAL+1))
+                        && (current_cid == 0) )
+        {
+                *err = EPERM;
+                sig_dmsg(1, "%s: can't kill process %u on cluster %u\n",           \
+                                __FUNCTION__, PID_GET_LOCAL(pid), current_cid);
+                goto SYS_RISE_ERR_PID;
+        }
+
+        /* Step 1 : lock the process manager */
+        processs_manager_lock();
+
+        /* Step 2 : Get the process' address */
+        /* Case 1 : current cluster is the anchor and the owner. */
+        if ( PID_GET_CLUSTER(pid) == current_cid )
+        {
+                sig_dmsg(1, "%s: process %u is in the processs manager array of cluster  %u\n",       \
+                                __FUNCTION__, pid, current_cid);
+                process = process_lookup(pid)->process;
+
+        }
+        else /* Case 2 : current cluster is not the anchor, so the struct
+              * process_s is in its hash table.
+              */
+        {
+                sig_dmsg(1, "%s: process %u is in the processs manager hash table of cluster  %u\n",  \
+                                __FUNCTION__, pid, current_cid);
+                hnode = hfind(processs_manager_get_htable(), (void*)pid);
+                process    = ( process_t*) container_of(hnode,          \
+                                 process_t, t_hnode);
+        }
+
+        /* Step 4 : check process' address */
+        if ( process == NULL )
+        {
+                *err = ESRCH;
+                goto SYS_RISE_ERR;
+        }
+
+        /* Step 5 : deliver signal */
+        if((sig == SIGTERM) || (sig == SIGKILL))
+                *err = signal_rise_all(process, sig);
+        else
+                *err = signal_rise_one(process, sig);
+
+        /* Step 6 : unlock processs manager */
+        processs_manager_unlock();
+
+        return;
+
+SYS_RISE_ERR:
+        processs_manager_unlock();
+SYS_RISE_ERR_PID:
+        sig_dmsg(1, "%s: Cluster %u has not deliver signal %u to process %u (err %u)\n",  \
+                        __FUNCTION__, current_cid, sig, err );
+
+        return;
+}
+
+//////////////////////////////////
+error_t signal_rise( pid_t    pid, 
+                     cxy_t    location, 
+                     uint32_t sig)
+{
+	error_t err;
+
+        /* Check location error */
+        if ( location == CID_NULL )
+        {
+                err = ESRCH;
+                printk(WARNING, "%s: there is no process with pid %u\n", \
+                                __FUNCTION__, pid);
+                return err;
+        }
+
+        err = EAGAIN;
+        RCPC( location, RPC_PRIO_SIG_RISE, __signal_rise,       \
+                        RPC_RECV( RPC_RECV_OBJ(err) ),          \
+                        RPC_SEND( RPC_SEND_OBJ(pid),            \
+                                  RPC_SEND_OBJ(sig))            \
+            );
+
+	return err;
+}
+
+////////////////////////////////////
+void signal_notify( thread_s * this)
+{
+	register uint32_t sig_state;
+	register uint32_t sig;
+	register struct sig_mgr_s *sig_mgr;
+	uint32_t irq_state;
+
+	sig_state = this->info.sig_state & this->info.sig_mask;
+	sig       = 0;
+ 
+	while((sig_state != 0) && ((sig_state & 0x1) == 0) && (sig < SIG_NR))
+	{
+		sig ++; 
+		sig_state >>= 1;
+	}
+  
+	if(sig)
+	{
+		cpu_disable_all_irq(&irq_state);
+
+		if(thread_isSignaled(this))
+		{
+			cpu_restore_irq(irq_state);
+			return;
+		}
+
+		thread_set_signaled(this);
+		cpu_restore_irq(irq_state);
+
+		spinlock_lock(&this->lock);
+		this->info.sig_state &= ~(1 << sig);
+		spinlock_unlock(&this->lock);
+
+		sig_mgr = &this->process->sig_mgr;
+
+		if(sig_mgr->sigactions[sig] == SIG_IGNORE)
+			return;
+
+		if(sig_mgr->sigactions[sig] == SIG_DEFAULT)
+			kill_sigaction(sig);
+
+		cpu_signal_notify(this, sig_mgr->sigactions[sig], sig);
+	}
+}
Index: trunk/kernel/kern/signal.h
===================================================================
--- trunk/kernel/kern/signal.h	(revision 1)
+++ trunk/kernel/kern/signal.h	(revision 1)
@@ -0,0 +1,180 @@
+/*
+ * signal.h - signal-management related operations
+ * 
+ * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *         Mohamed Lamine Karaoui (2015) 
+ *         Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SIGNAL_H_
+#define _SIGNAL_H_
+
+#include <hal_types.h>
+
+#define SIG_DEFAULT    (void*)0L
+#define SIG_IGNORE     (void*)1L
+#define SIG_ERROR     -1L
+
+#define SIGHUP     1       /*! hangup */
+#define SIGINT     2       /*! interrupt */
+#define SIGQUIT    3       /*! quit */
+#define SIGILL     4       /*! illegal instruction (not reset when caught) */
+#define SIGTRAP    5       /*! trace trap (not reset when caught) */
+#define SIGIOT     6       /*! IOT instruction */
+#define SIGABRT    6       /*! used by abort, replace SIGIOT in the future */
+#define SIGEMT     7       /*! EMT instruction */
+#define SIGFPE     8       /*! floating point exception */
+#define SIGKILL    9       /*! kill (cannot be caught or ignored) */
+#define SIGBUS     10      /*! bus error */
+#define SIGSEGV    11      /*! segmentation violation */
+#define SIGSYS     12      /*! bad argument to system call */
+#define SIGPIPE    13      /*! write on a pipe with no one to read it */
+#define SIGALRM    14      /*! alarm clock */
+#define SIGTERM    15      /*! software termination signal from kill */
+#define SIGURG     16      /*! urgent condition on IO channel */
+#define SIGSTOP    17      /*! sendable stop signal not from tty */
+#define SIGTSTP    18      /*! stop signal from tty */
+#define SIGCONT    19      /*! continue a stopped process */
+#define SIGCHLD    20      /*! to parent on child stop or exit */
+#define SIGCLD     20      /*! System V name for SIGCHLD */
+#define SIGTTIN    21      /*! to readers pgrp upon background tty read */
+#define SIGTTOU    22      /*! like TTIN for output if (tp->t_local&LTOSTOP) */
+#define SIGIO      23      /*! input/output possible signal */
+#define SIGPOLL    SIGIO   /*! System V name for SIGIO */
+#define SIGXCPU    24      /*! exceeded CPU time limit */
+#define SIGXFSZ    25      /*! exceeded file size limit */
+#define SIGVTALRM  26      /*! virtual time alarm */
+#define SIGPROF    27      /*! profiling time alarm */
+#define SIGWINCH   28      /*! window changed */
+#define SIGLOST    29      /*! resource lost (eg, record-lock lost) */
+#define SIGUSR1    30      /*! user defined signal 1 */
+#define SIGUSR2    31      /*! user defined signal 2 */
+#define SIG_NR     32      /*! signal 0 implied */
+
+#define SIG_DEFAULT_MASK         0xFFEEFFFF
+#define SIG_DEFAULT_STACK_SIZE   2048
+
+/****  Forward declarations  ****/
+
+struct process_s;
+struct thread_s;
+
+typedef uint32_t         sigval_t;
+typedef uint32_t         sigset_t;
+
+/*******************************************************************************************
+ * This structure ...
+ ******************************************************************************************/
+
+typedef struct siginfo_s
+{
+	int      si_signo;    /*! Signal number */
+	int      si_errno;    /*! An errno value */
+	int      si_code;     /*! Signal code */
+	pid_t    si_pid;      /*! Sending process ID */
+	uid_t    si_uid;      /*! Real user ID of sending process */
+	int      si_status;   /*! Exit value or signal */
+	clock_t  si_utime;    /*! User time consumed */
+	clock_t  si_stime;    /*! System time consumed */
+	sigval_t si_value;    /*! Signal value */
+	int      si_int;      /*! POSIX.1b signal */
+	void    *si_ptr;      /*! POSIX.1b signal */
+	void    *si_addr;     /*! Memory location which caused fault */
+	int      si_band;     /*! Band event */
+	int      si_fd;       /*! File descriptor */
+}
+siginfo_t;
+
+/*******************************************************************************************
+ * This structure ...
+ ******************************************************************************************/
+
+typedef void (sa_handler_t) ( uint32_t sig );
+
+typedef struct sigaction_s 
+{
+	sigset_t sa_mask;
+	uint32_t sa_flags;
+	union
+	{ 
+		sa_handler_t *sa_handler;
+		void (*sa_sigaction)(int, siginfo_t *, void *);
+	};
+}
+sigaction_t;
+
+/*******************************************************************************************
+ * This structure TODO
+ ******************************************************************************************/
+
+typedef struct sig_mgr_s
+{
+	sa_handler_t        * sigactions[SIG_NR];
+ ster   struct thread_s     * handler;
+}
+sig_mgr_t;
+
+
+/*******************************************************************************************
+ * This function TODO
+ ******************************************************************************************/
+int sys_signal ( uint32_t       sig, 
+                 sa_handler_t * handler );
+
+/*******************************************************************************************
+ * This function TODO
+ ******************************************************************************************/
+int sys_sigreturn_setup( void * sigreturn_func );
+
+/*******************************************************************************************
+ * This function TODO
+ ******************************************************************************************/
+int sys_kill( pid_t    pid,
+              uint32_t sig );
+
+/*******************************************************************************************
+ * This function TODO
+ ******************************************************************************************/
+error_t signal_manager_init( struct process_s * process );
+
+/*******************************************************************************************
+ * This function TODO
+ ******************************************************************************************/
+error_t signal_init( struct thread_s * thread );
+
+/*******************************************************************************************
+ * This function register the signal <sig> in the bit-vector of all threads of a given
+ * process identified by its <pid>, on all clusters containing a thread .
+ * It can be executed by any thread running in any cluster.
+ ******************************************************************************************/
+error_t signal_rise( pid_t     pid, 
+                     uint32_t  sig );
+
+/*******************************************************************************************
+ * This function TODO
+ ******************************************************************************************/
+void signal_notify( struct thread_s * this);
+
+/*******************************************************************************************
+ * This function do nothing in this implementation.
+ ******************************************************************************************/
+#define signal_manager_destroy(task)
+
+#endif	/*! _SIGNAL_H_ */
Index: trunk/kernel/kern/sys-vfs.h
===================================================================
--- trunk/kernel/kern/sys-vfs.h	(revision 1)
+++ trunk/kernel/kern/sys-vfs.h	(revision 1)
@@ -0,0 +1,58 @@
+/*
+ * kern/sys-vfs.h - exported file management services
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SYS_VFS_H_
+#define _SYS_VFS_H_
+
+#include <types.h>
+#include <vfs.h>
+
+struct vfs_usp_dirent_s;
+
+/* Files related system call */
+int sys_open (char *pathname, uint_t flags, uint_t mode);
+int sys_stat (char *path, struct vfs_stat_s *buf, int fd);
+int sys_creat (char *pathname, uint_t mode);
+int sys_read (uint_t fd, void *buf, size_t count);
+int sys_write (uint_t fd, void *buf, size_t count);
+int sys_lseek (uint_t fd, off_t offset, int whence);
+int sys_unlink (char *pathname);
+int sys_close (uint_t fd);
+
+/* Directories related system call */
+int sys_opendir (char *pathname);
+int sys_mkdir (char *pathname, uint_t mode);
+int sys_rmdir (char *pathname);
+int sys_chdir (char *pathname);
+int sys_readdir (uint_t fd, struct vfs_usp_dirent_s *dirent);
+int sys_closedir (uint_t fd);
+int sys_getcwd (char *buff, size_t size);
+
+/* Common */
+int sys_chmod (char *pathname, uint_t mode);
+int sys_fsync (uint_t fd);
+
+/* Anonymous/Named pipes related system call */
+int sys_pipe (uint_t *pipefd);
+int sys_mkfifo (char *pathname, uint_t mode);
+
+#endif
Index: trunk/kernel/kern/sysconf.c
===================================================================
--- trunk/kernel/kern/sysconf.c	(revision 1)
+++ trunk/kernel/kern/sysconf.c	(revision 1)
@@ -0,0 +1,85 @@
+/*
+ * kern/sysconf.c - interface to access system exported configurations
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <config.h>
+#include <libk.h>
+#include <system.h>
+#include <sysfs.h>
+#include <arch.h>
+#include <pmm.h>
+#include <thread.h>
+#include <sysconf.h>
+
+static sysfs_entry_t sysconf;
+static void sysconf_sysfs_op_init(sysfs_op_t *op);
+
+error_t sysconf_init(void)
+{
+	sysfs_op_t op;
+
+	sysconf_sysfs_op_init(&op);
+	sysfs_entry_init(&sysconf, &op, 
+#if CONFIG_ROOTFS_IS_VFAT
+			 "SYSCONF"
+#else
+			 "sysconf"
+#endif
+		);
+	sysfs_entry_register(&sysfs_root_entry, &sysconf);
+
+	return 0;
+}
+
+static error_t sysconf_sysfs_read_op(sysfs_entry_t *entry, sysfs_request_t *rq, uint_t *offset)
+{
+	struct thread_s *this;
+
+	if(*offset != 0)
+	{
+		*offset   = 0;
+		rq->count = 0;
+		return 0;
+	}
+  
+	this = current_thread;
+
+	sprintk((char*)rq->buffer, 
+		"CLUSTER_ONLN_NR %d\nCPU_ONLN_NR %d\nCPU_CACHE_LINE_SIZE %d\nPAGE_SIZE %d\nHEAP_MAX_SIZE %d\n",
+		arch_onln_cluster_nr(),
+		arch_onln_cpu_nr(), 
+		CACHE_LINE_SIZE, 
+		PMM_PAGE_SIZE,
+		CONFIG_TASK_HEAP_MAX_SIZE);
+  
+	rq->count = strlen((const char*)rq->buffer); 
+	*offset   = 0;
+	return 0;
+}
+
+static void sysconf_sysfs_op_init(sysfs_op_t *op)
+{
+	op->open  = NULL;
+	op->read  = sysconf_sysfs_read_op;
+	op->write = NULL;
+	op->close = NULL;
+}
Index: trunk/kernel/kern/sysconf.h
===================================================================
--- trunk/kernel/kern/sysconf.h	(revision 1)
+++ trunk/kernel/kern/sysconf.h	(revision 1)
@@ -0,0 +1,30 @@
+/*
+ * kern/sysconf.h - interface to access system exported configurations
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SYSCONF_H_
+#define _SYSCONF_H_
+
+#include <types.h>
+
+error_t sysconf_init(void);
+
+#endif	/* _SYSCONF_H_ */
Index: trunk/kernel/kern/thread.c
===================================================================
--- trunk/kernel/kern/thread.c	(revision 690)
+++ trunk/kernel/kern/thread.c	(revision 1)
@@ -1,17 +1,18 @@
 /*
- * thread.c -   thread operations implementation (user & kernel)
- *
+ * thread.c -  implementation of thread operations (user & kernel)
+ * 
  * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
- *         Alain Greiner    (2016,2017,2018,2019,2020)
+ *         Mohamed Lamine Karaoui (2015)
+ *         Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-MKH.
+ * This file is part of ALMOS-MKH..
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -19,16 +20,14 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_context.h>
 #include <hal_irqmask.h>
 #include <hal_special.h>
 #include <hal_remote.h>
-#include <hal_vmm.h>
-#include <hal_switch.h>
 #include <memcpy.h>
 #include <printk.h>
@@ -36,5 +35,5 @@
 #include <process.h>
 #include <scheduler.h>
-#include <dev_pic.h>
+#include <dev_icu.h>
 #include <core.h>
 #include <list.h>
@@ -44,5 +43,4 @@
 #include <ppm.h>
 #include <thread.h>
-#include <rpc.h>
 
 //////////////////////////////////////////////////////////////////////////////////////
